#include <GL/glut.h>
#include "glyph.h"

static void reshape(int w, int h)
{
	glViewport(0, 0, w, h);

	glMatrixMode(GL_PROJECTION);
	{
		glLoadIdentity();
		glOrtho(0, 16, 0, 8, -1, 1);
	}
	glMatrixMode(GL_MODELVIEW);
}

static void display(void)
{
	int i, j;

	glClear(GL_COLOR_BUFFER_BIT);

	glPushMatrix();
	{
		glTranslatef(0.0, 7.0, 0.0);

		for (i = 0; i < 128; i += 16)
		{
			glPushMatrix();
			{
				for (j = i; j < i + 16; j++)
					draw_glyph(j);
			}
			glPopMatrix();

			glTranslatef(0.0, -1.0, 0.0);
		}
	}
	glPopMatrix();

	glutSwapBuffers();
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);

	glutInitWindowSize(512, 512);
	glutCreateWindow(argv[0]);

	glutReshapeFunc(reshape);
	glutDisplayFunc(display);

	glutMainLoop();

	return 0;
}
